

//#define UART_BAUD_RATE	57600

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

///SYSINFO



#define DATUM		"15.09.2009"
#define FUNKTION	"Lauflicht"
#define UHRZEIT		"12:00"
#define AUTOR		"Christof Ermer"



/*
HYSTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

/*
#define UART_BAUD_RATE	57600
#define F_CPU	16000000
*/

//#define AVR_ATmega16//in io.h  elif defined (__AVR_ATmega8__)#  include <avr/iom8.h>

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr\eeprom.h>	

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>

//#include <avr\twi.h> /* Note [1] */  // NEUE DATEIVERSION_STR BEUNTZEN
//#include <avr\signal.h> //#include <signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//with Hardware assigns
#include "uart.h"

int32_t Round(double fIn);

#if TIMER2_TICK_USED == 1
void StartTimer2(void);	//0.1 Seconds  interrupt
uint32_t GetTickDifference(uint32_t u32Time);
#endif


#if UART_USE_ENABLED == 1
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);
void PrintStrCR(const char* pStr);
void CheckOrder(char* pcStr);
void LongToNumStr(int32_t lVal);
void FloatToNumStr(double fVal);
#endif


///CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_VERSION[] PROGMEM = VERSION;


const char MCA_STARTREKBLINKER[] PROGMEM = { 0b00011000,0b00100100,0b01000010,0b10000001,0b01000010,0b00100100};



#if TEXT_SERVICE_USE_ENABLED == 1
const char MCA_CRSTR[] PROGMEM = {13,0};
const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
#endif


#if UART_ERRORMSG == 1
const char MCA_UARTErr_MSG[] PROGMEM = "UartEr";
#endif


// GLOBALE VARIABLEN 
//MSG
const char MCA_SPACE_MSG[] PROGMEM	= " ";
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
const char MCA_ISTGLEICH_MSG[] PROGMEM	= "=";
const char MCA_STERN_MSG[] PROGMEM	= "*";
const char MCA_VALUE_MSG[] PROGMEM	= "Value";


const char MCA_SPC_CMD[]PROGMEM = "SPC"; // Set PortC
const char MCA_RPC_CMD[]PROGMEM = "RPC"; // REad PortC


const char MCA_PING_CMD[] PROGMEM = "PING";	 //CONST ARRAY
const char MCA_PONG_MSG[] PROGMEM	= "PONG";
const char MCA_OK_MSG[] PROGMEM	= "OK";


#if UART_USE_ENABLED == 1
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif

//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
static volatile  uint32_t gu32T2_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
# if USE_ERROR_FLAG == 1
uint8_t gbErrorFlag;
#endif



#if TIMER2_TICK_USED == 1
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32T2_Ticks++;
#if UART_USE_ENABLED ==1
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTimer2(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32T2_Ticks = OCR2 = TCNT2 = 0;  //Timer MAX = TOP Compare
//ASSR &= ~(_BV(AS2)); //ASS2  CLOCK FREIGABE von QUARZ
//SFIOR |= PSR2; //RESET COUNTER
//8 Bit Timerx00);	//Timer Inhalt
// 16 MHZ  / 64 = 250000
//250000 / 256 = 3906,25  Intterrupts / Sekunde
//(1/3906,25)  = 0,000256 =  Zeit in Sek/ Interrupt
// SYSCLK_256 / 64 =  675 = 0,0014814814814814814814814814814815   mS Interrrupt
//TIMER STARTS with Presscale Select = 64
TIFR |= TIFR_OCF2_OUTP_COMPARE_FLAG | TIFR_TOV2_TIMER_OVERFLOW_FLAG ; // zum lschen setzen!
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};


// ****************************************************************
uint32_t GetTickDifference(uint32_t u32Time)
// ****************************************************************
{
return (gu32T2_Ticks - u32Time);
};


// *************************************
void Timer_Init(void) 
// *************************************
/* initialize timer 2 */
{
// obsolte in neuer Version timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
timer_enable_int(0);// outp(0, TIMSK);	/* disable timer interrupts */
StartTimer2();	//8 Bit Timer 2 = MS Tick Counter
};


#if USE_TOGGLE_FLAG == 1
// ****************************************************************
void ToggleTEST_BIT(uint8_t ucCnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
uint8_t ucNN;
for(ucNN=0; ucNN < ucCnt; ucNN++)
	{
	SET_TESTBIT_MAC;
	_delay_us(1);
	CLR_TESTBIT_MAC;
	_delay_us(1);
	};
};
#endif




#if UART_USE_ENABLED == 1
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#if UART_ERRORMSG == 1
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  MCA_UARTErr_MSG );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif




#if UART_USE_ENABLED == 1
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#if UART_USE_ENABLED == 1  //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_puts_p( MCA_CRSTR );
};


// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};


// **********************************************
void FloatToNumStr(double fVal)
// *************
{
sprintf(gcaNumStr,"%.1f", fVal);
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
//sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
sprintf(gcaNumStr,"%li", lVal);  //Ulong = %ld
};


// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};


#endif

#if  (UART_USE_ENABLED == 1) && (USED_HEX_CONVERSION == 1)
// *******************************************************************
void PrintHexCR(uint16_t uiVal)
// *******************************************************************
{
ULongToHexNumStr(uiVal); PrintStrCR(gcaNumStr);
};
#endif


// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SPC_CMD) ) 
	{
	DDRC=0XFF;
	PORTC = (uint8_t)gsCmd.fCmdVal_1;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_RPC_CMD) ) 
	{
	DDRC=0X00;
	PORTC = 0X00; // 
	LongToNumStr(PINC);	
	PrintStrCR(gcaNumStr);
	};	


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_PING_CMD)  )    //ping
	{	
	Print_PStrCR( MCA_PONG_MSG );
	};

# if EEPROM_USED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_SAVE_CMD) )
	{
	SaveParameter();
	};


if( !strcasecmp_P( gsCmd.ucaCmd, MCA_LOAD_CMD) ) 
	{
	LoadParameter();
	};
#endif	

#if ADC_USED_ENABLED == 1
if( !strcasecmp_P( gsCmd.ucaCmd, MCA_ADC_CMD)  )    //ADC,0..7
	{	
	uart_puts_p( MCA_ADC_CMD );
	uart_puts_p( MCA_ISTGLEICH_MSG );	
	PrintLongCR( ADC_10Bit( gsCmd.fCmdVal_1 ) );
	};
#endif

 #if ENDORDER_CMD_ECHO_ENABLED == 1
 Print_PStrCR( MCA_OK_MSG );   
//PrintStrCR(gsCmd.ucaCmd);   
#endif
 };



#if ADC_USED_ENABLED == 1
//PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnwsscht
//REM ADC4-ADC5 = 8 BIT;
//4+2 Channel. 
//  ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----
unsigned int ADC_10Bit(unsigned char ucChan)
//  ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----ADC_INTERN-----
{
 
 //AUCH COMPARATOR ACSR ( ACME ADEN
 DDRC &= ~(1<<ucChan);  //port A Chanel Bit Input
  // Activate ADC with Prescaler 16 --> 1Mhz/16 = 62.5kHz
 ADCSRA = ADCSRA_ADEN | ADCSRA_PRESCALER_32; //ADCSRA_ADPS0 | ADCSRA_ADPS2; // Prescale 32 = 115200 Hz
 // Select pin ADC--x using MUX
 ADMUX = (ucChan & ADC_MUX_MASK);
    //Start conversion
 ADCSRA |= ADCSRA_ADSC | ADCSRA_ADEN;
    // wait until converstion completed
 while(ADCSRA & ADCSRA_ADSC ) 
	{
	wdt_reset();
	};
 return    ADCW; // get converted value
};
#endif


// *******************************************************************
int main(void)
// *******************************************************************
{
//static uint16_t uiNN;
static uint8_t u8ArrayCnt;
static uint32_t ullNow;
static uint8_t u8Val;
static uint8_t u8InvVal;
static uint16_t u16Val;
static uint8_t u8Switch;
static uint32_t u32MainCnt;
static uint32_t u32SecNow;

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUTMASK;
PORTA = PORTA_PRESET_PULLMASK;
DDRB = PORTB_DDRX_OUTMASK;
PORTB = PORTB_PRESET_PULLMASK;
DDRC = PORTC_DDRX_OUTMASK;
PORTC = PORTC_PRESET_PULLMASK;
DDRD = PORTD_DDRX_OUTMASK;	
PORTD = PORTD_PRESET_PULLMASK;

//INTERRUPT MODE EiNSTELLEMN;
StartTimer2();	//8 Bit Timer 2 = MS Tick Counter

// ZUM LESEN IMMER PINx verwenden
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
//The global interrupt flag is maintained in the I bit of the status register (SREG).
ACSR |= _BV( ACD) | _BV( ACBG); // + BANDGAP

/*
cbi(ACSR, ACIE);	//Analog Comaprator Interrupt dissable
cbi(ACSR, ACI);		//Analog Comaprator Interrupt FLAG dissable
sbi(ACSR, ACD);  	//Analog Comparator PWR Disable 
*/

ResetRxBuff();
      // Initialize UART library, pass baudrate and avr cpu clock
     //  with the macro UART_BAUD_SELECT()
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
sei();



#if EEPROM_USED == 1
//VERIY IMPORTANT....
//BEI FEHLER (EEPROM UNBESCHRIEBEN ; LADE WERTE
if( CheckEEPROM_Valid() )//return 0 = WRONG
	{
	LoadParameter();	//EEprom VALID CHECK INCLUDED !!!
	}
else
	{
	SaveParameter();
	};
#endif

// ************ MAIN LOOP FOR EVER *********************
// ************ MAIN LOOP FOR EVER *********************
u8Val = ullNow = gu32T2_Ticks = 0;

DDRA = 0XFF;
PORTA=0;

DDRB= 0;
DDRC= 0xFF;

DDRD = PORTD_DDRX_OUTMASK;	

SFIOR = (1<<PUD); //Pullup Disable
GICR = 0;

DDRB = 0xFF;


uart_puts_p( MCA_PONG_MSG );
_delay_ms(50);

u8InvVal=7;
u8Val=0;
u32MainCnt = 0;

for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
	{	
	sei();
 	wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

	u32MainCnt++;
 

if( GetTickDifference(u32SecNow) >  PULS_PER_SEcONDTick_T2 )	//56.25
	{
	u32SecNow = gu32T2_Ticks; //Zeit merken !!
	PrintLongCR( u32MainCnt );
	u32MainCnt = 0;
	};


//PULS_PER_10TEL_SEc_T2
if( GetTickDifference(ullNow) >  PULS_100MS_TICK_T2 )	//56.25
	{
	ullNow = gu32T2_Ticks; //Zeit merken !!
	
	//LAUFLICHT_DIRECTION_PORT  = 0b11111111 // PORT C; ALLES OUT OUT 
	
	u8Val %= 8; // MODULO = 0...7, dann wieder 0	
	u8InvVal %=8;
	PORTC = (1 << u8Val);	
	PORTA = (1 << u8InvVal);	
	u8Val++;
	u8InvVal--;

	
	
	PORTB = pgm_read_byte( MCA_STARTREKBLINKER + u8ArrayCnt );
	u8ArrayCnt++;
	u8ArrayCnt %= STARTREKBLINKER_CNTS; // 6 
	//Kuerzere VERSION:
	//LAUFLICHT_PORT = (1 << u8Val++); 
	};
 
  // Das nennt man POLLING Betrieb
	if( BOARD_HW_PORT_IN & KEY1_MASKE)
		{
		BOARD_HW_PORT_OUT |= LED1_MASKE;
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~LED1_MASKE;
		};
	
	if( BOARD_HW_PORT_IN & KEY2_MASKE)
		{
		BOARD_HW_PORT_OUT |= LED2_MASKE;
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~LED2_MASKE;
		};
	
		
	if(BOARD_HW_PORT_IN & KEY3_MASKE)
		{
		BOARD_HW_PORT_OUT |= SUMMER_MASKE;
		}
	else
		{
		BOARD_HW_PORT_OUT &= ~SUMMER_MASKE;
		};
	}; // main   END END *************
};
// ******************* MAIN END ********************************************

